
package context;

import java.util.logging.Level;
import java.util.logging.Logger;


/**Class that stores data taken from an available interface. */
public class InterfaceData implements Cloneable
{
    private String name;
    private String mac_address;
    private String ip_address;
    private String subnetmask;
    private String network_address;
    private String broadcast_address;
    private String default_gateway;
    private String max_bitrate;
    private String current_bitrate;
    private String current_usedrange;
    private String packet_error_rate;
    
    
    /**Creates an IntrerfaceData object.
     * @param s the name of the interface we want to create*/
    public InterfaceData( String s )
    {
        this.name = s;
    }
    
    public InterfaceData()
    {

    }
    

    public String getBroadcast_address()
    {
        return broadcast_address;
    }

    public void setBroadcast_address(String broadcast_address)
    {
        this.broadcast_address = broadcast_address;
    }

    public String getCurrent_bitrate()
    {
        return current_bitrate;
    }

    public void setCurrent_bitrate(String current_bitrate)
    {
        this.current_bitrate = current_bitrate;
    }

    public String getCurrent_usedrange()
    {
        return current_usedrange;
    }

    public void setCurrent_usedrange(String current_usedrange)
    {
        this.current_usedrange = current_usedrange;
    }

    public String getDefault_gateway()
    {
        return default_gateway;
    }

    public void setDefault_gateway(String default_gateway)
    {
        this.default_gateway = default_gateway;
    }

    public String getSubnetmask()
    {
        return subnetmask;
    }

    public void setSubnetmask(String subnetmask)
    {
        this.subnetmask = subnetmask;
    }

    public String getName()
    {
        return name;
    }

    public void setName(String name)
    {
        this.name = name;
    }

    public String getIp_address()
    {
        return ip_address;
    }

    public void setIp_address(String ip_address)
    {
        this.ip_address = ip_address;
    }

    public String getMac_address()
    {
        return mac_address;
    }

    public void setMac_address(String mac_address)
    {
        this.mac_address = mac_address;
    }

    public String getMax_bitrate()
    {
        return max_bitrate;
    }

    public void setMax_bitrate(String max_bitrate)
    {
        this.max_bitrate = max_bitrate;
    }

    public String getNetwork_address()
    {
        return network_address;
    }

    public void setNetwork_address(String network_address)
    {
        this.network_address = network_address;
    }

    public String getPacket_error_rate()
    {
        return packet_error_rate;
    }

    public void setPacket_error_rate(String packet_error_rate)
    {
        this.packet_error_rate = packet_error_rate;
    }
    
    @Override
    public boolean equals( Object o )
    {
        if ( !(o instanceof InterfaceData))
        {
            return false;
        }
        InterfaceData interf = (InterfaceData) o;
        
        if ( !this.mac_address.equals(interf.getMac_address()) )
        {
            return false;
        }
        
        if ( !this.ip_address.equals(interf.getIp_address()) )
        {
            return false;
        }
        
        if ( !this.default_gateway.equals(interf.getDefault_gateway()) )
        {
            return false;
        } 
        
        if ( !this.subnetmask.equals(interf.getSubnetmask()) )
        {
            return false;
        }
        
        if ( !this.current_usedrange.equals(interf.getCurrent_usedrange()) )
        {
            return false;
        }   
        
        if ( !this.packet_error_rate.equals(interf.getPacket_error_rate()) )
        {
            return false;
        }        
        
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 59 * hash + (this.mac_address != null ? this.mac_address.hashCode() : 0);
        hash = 59 * hash + (this.ip_address != null ? this.ip_address.hashCode() : 0);
        hash = 59 * hash + (this.subnetmask != null ? this.subnetmask.hashCode() : 0);
        hash = 59 * hash + (this.default_gateway != null ? this.default_gateway.hashCode() : 0);
        hash = 59 * hash + (this.current_usedrange != null ? this.current_usedrange.hashCode() : 0);
        hash = 59 * hash + (this.packet_error_rate != null ? this.packet_error_rate.hashCode() : 0);
        return hash;
    }
    
    @Override
    public Object clone()
    {
        try
        {
            return super.clone();
        } catch (CloneNotSupportedException ex)
        {
            Logger.getLogger(InterfaceData.class.getName()).log(Level.SEVERE, null, ex);
            System.exit(1);
        }
        return null;
    }
    
    @Override
    public String toString()
    {
        String sdata="";
        
        sdata = sdata.concat("\nInterface name: " + this.getName()+"\n");
        sdata = sdata.concat("Mac: " + this.getMac_address()+"\t");
        sdata = sdata.concat("IP: " + this.getIp_address()+"\t");
        sdata = sdata.concat("Bcast: " + this.getBroadcast_address()+"\n");
        sdata = sdata.concat("Mask: " + this.getSubnetmask()+"\t");
        sdata = sdata.concat("NetAddr: " + this.getNetwork_address()+"\t");
        sdata = sdata.concat("Gateway: " + this.getDefault_gateway()+"\n");
        sdata = sdata.concat("MaxBitRate: " + this.getMax_bitrate()+"\t");
        sdata = sdata.concat("CurBitRate: " + this.getCurrent_bitrate()+"\n");
        sdata = sdata.concat("UsedRange: " + this.getCurrent_usedrange()+"\t");
        sdata = sdata.concat("ErrorRate: " + this.getPacket_error_rate()+"\n");        
        
        return sdata;      
    }    
}
