
package context;

public class TerminalData
{
    private String model;
    private String manufacturer;
    private String version;

    private double latitude;
    private double longitude;

    private int batteryLevel;
    private boolean charging;
    
    public TerminalData(String data)
    {
        String str[] = data.split(":");
        
        this.model = str[0];
        this.manufacturer = str[1];
        this.version = str[2];
        this.latitude = Double.parseDouble(str[3]);
        this.longitude = Double.parseDouble(str[4]);
        this.batteryLevel = Integer.parseInt(str[5]);
        this.charging = ( str[6].equals("Charging") ? true : false);
    }

    public String getModel()
    {
            return model;
    }

    public String getManufacturer()
    {
            return manufacturer;
    }

    public String getVersion()
    {
            return version;
    }

    public int getBatteryLevel()
    {
            return batteryLevel;
    }

    public boolean isCharging()
    {
            return charging;
    }

    public double getLatitude()
    {
            return latitude;
    }

    public double getLongitude()
    {
            return longitude;
    }

    public void setLatitude(double latitude)
    {
            this.latitude = latitude;
    }

    public void setLongitude(double longitude)
    {
            this.longitude = longitude;
    }

    public void setBatteryLevel(int batteryLevel)
    {
            this.batteryLevel = batteryLevel;
    }

    public void setCharging(boolean charging)
    {
            this.charging = charging;
    }

    @Override
    public String toString()
    {
            String temp;

            temp = this.model+":"+this.manufacturer+":"+this.version+":"+String.valueOf(this.latitude)+":"+String.valueOf(this.longitude)+
                            ":"+String.valueOf(this.batteryLevel)+":"+(this.isCharging()? "Charging" : "Not Charging");
            return temp;
    }        
	
}
