
package context;


/**Class that stores data taken from an available wireless interface. */
public class WirelessData extends InterfaceData
{
    private String ap_mac_address;
    private String ap_essid;
    private String channel;
    private String ap_mode;
    private String transmit_power;
    private String link_quality;
    private String signal_level;
    private String noise_level;
    private String discarded_packets;
    
    
    /**Creates a WirelessData object.
     * @param s the name of the wireless interface we want to create*/
    public WirelessData( String s )
    {
        super(s);
    } 
    
    public WirelessData()
    {

    }    

    public String getAp_essid()
    {
        return ap_essid;
    }

    public void setAp_essid(String ap_essid)
    {
        this.ap_essid = ap_essid;
    }

    public String getAp_mac_address()
    {
        return ap_mac_address;
    }

    public void setAp_mac_address(String ap_mac_address)
    {
        this.ap_mac_address = ap_mac_address;
    }

    public String getDiscarded_packets()
    {
        return discarded_packets;
    }

    public void setDiscarded_packets(String dropped_packages_num)
    {
        this.discarded_packets = dropped_packages_num;
    }

    public String getChannel()
    {
        return channel;
    }

    public void setChannel(String channel)
    {
        this.channel = channel;
    }
    public String getAp_mode() {
        return ap_mode;
    }

    public void setAp_mode(String ap_mode) {
        this.ap_mode = ap_mode;
    }

    public String getTransmit_power() {
        return transmit_power;
    }

    public void setTransmit_power(String transmit_power) {
        this.transmit_power = transmit_power;
    }

    public String getLink_quality() {
        return link_quality;
    }

    public void setLink_quality(String link_quality) {
        this.link_quality = link_quality;
    }

    public String getSignal_level() {
        return signal_level;
    }

    public void setSignal_level(String signal_level) {
        this.signal_level = signal_level;
    }

    public String getNoise_level() {
        return noise_level;
    }

    public void setNoise_level(String noise_level) {
        this.noise_level = noise_level;
    }
    
    
    @Override
    public boolean equals( Object o )
    {
        if ( !(o instanceof WirelessData) )
        {
            return false;
        }
        WirelessData winterf = (WirelessData) o;
        
        if ( !this.transmit_power.equals(winterf.getTransmit_power()) )
        {
            return false;
        }
        
        if ( !this.signal_level.equals(winterf.getSignal_level()) )
        {
            return false;
        }
        
        if ( !this.noise_level.equals(winterf.getNoise_level()) )
        {
            return false;
        }   
        
        if ( !super.equals(winterf) )
        {
            return false;
        }
        
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 97 * hash + (this.transmit_power != null ? this.transmit_power.hashCode() : 0);
        hash = 97 * hash + (this.signal_level != null ? this.signal_level.hashCode() : 0);
        hash = 97 * hash + (this.noise_level != null ? this.noise_level.hashCode() : 0);
        return hash;
    }
    
    @Override
    public Object clone()
    {
        return super.clone();
    }    
    
    @Override
    public String toString()
    {
        String sdata="";
        
        sdata = sdata.concat("\nWireless name: " + this.getName()+"\n");
        sdata = sdata.concat("Mac: " + this.getMac_address()+"\t");
        sdata = sdata.concat("IP: " + this.getIp_address()+"\t");
        sdata = sdata.concat("Bcast: " + this.getBroadcast_address()+"\n");
        sdata = sdata.concat("Mask: " + this.getSubnetmask()+"\t");
        sdata = sdata.concat("NetAddr: " + this.getNetwork_address()+"\t");
        sdata = sdata.concat("Gateway: " + this.getDefault_gateway()+"\n");
        sdata = sdata.concat("MaxBitRate: " + this.getMax_bitrate()+"\t");
        sdata = sdata.concat("CurBitRate: " + this.getCurrent_bitrate()+"\n");
        sdata = sdata.concat("UsedRange: " + this.getCurrent_usedrange()+"\t");
        sdata = sdata.concat("ErrorRate: " + this.getPacket_error_rate()+"\n");
        sdata = sdata.concat("Essid: " + this.getAp_essid()+"\t");
        sdata = sdata.concat("ApMac: " + this.getAp_mac_address()+"\t");
        sdata = sdata.concat("ApMode: " + this.getAp_mode()+"\n");
        sdata = sdata.concat("Channel: " + this.getChannel()+"\t");
        sdata = sdata.concat("Tx-Power: " + this.getTransmit_power()+"\n");
        sdata = sdata.concat("LinkQuality: " + this.getLink_quality()+"\t");
        sdata = sdata.concat("SignalLevel: " + this.getSignal_level()+"\t");
        sdata = sdata.concat("NoiseLevel: " + this.getNoise_level()+"\n");
        sdata = sdata.concat("DiscardedPacks: " + this.getDiscarded_packets()+"\n");        
        
        return sdata;      
    }     
        
}
