
package server;

import context.MonitorData;
import context.TerminalData;
import javax.jws.WebMethod;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;
import javax.jws.soap.SOAPBinding.Style;


/**The interface of the web service. */
@WebService
@SOAPBinding(style=Style.DOCUMENT)
public interface TestWebService
{
    /**Web method that gets the name of the device and the data collected by it.
     * @param device The name of the device
     * @param MD MonitorData object that contains the data from the device */
    @WebMethod
    public void setMonitorData(String device, MonitorData MD);
     
    /**Web method that gets the name of the cell phone and the data collected by it.
     * @param device The name of the cell phone
     * @param data TerminalData object that contains the data from the cell phone */
    @WebMethod 
    public void setTerminalData(String device, String data);    
}
