package gr.askisi3.data;

import java.util.Properties;

/**AppData object that stores all the data that are required
 * for the application to run. */
public class AppData
{
    /**The private instance of this singleton class. */
    private static AppData instance = null;	
	
	/**Boolean that shows if the thread for monitoring-GPS is running. */
	public boolean gpsThread;
	/**Boolean that shows if the thread for monitoring-Battery is running. */
	public boolean batThread;
	/**Boolean that shows if the thread for sending the
	 * data to the web-service is running. */
	public boolean sendThread;
	
	/**Variable that stores the instance of the thread for the gps monitoring*/	
	public Thread gpsBackground;
	/**Variable that stores the instance of the thread for the battery monitoring*/	
	public Thread batBackground;
	/**Variable that stores the instance of the thread for sending data to the web-service*/	
	public Thread sendBackground;
	
	/**Properties object to load the program configurations. */
	public Properties props = new Properties();	
	
    /**Private constructor that initiates the values. */	
	private AppData()
	{
		gpsThread = false;
		batThread = false;
		sendThread = false;
		
		gpsBackground = null;
		batBackground = null;
		sendBackground = null;		
	}
	
    /**Creates the unique object of this class if not created.
     * @return The unique instance to this singleton class*/
    public static synchronized AppData getInstance()
    {
        if (instance == null)
        {
            instance = new AppData();
        }
        return instance;
    }
    
    @Override
    public Object clone() throws CloneNotSupportedException
    {
        throw new CloneNotSupportedException();
    }	
	
}
